<?php

if(defined('CONFIGURATION_FILE'))
{
	$cf = new configuration(CONFIGURATION_FILE);
	$CONFIG_OBJ = $cf -> get();
	//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($CONFIG_OBJ, true).'</pre>';die;
}

function get_module_obj($k, $n = false, $def = ''){
	if(isset($GLOBALS['MODULES_START']) && isset($GLOBALS['MODULES_START'][$k]))
	{		
		return $n? (isset($GLOBALS['MODULES_START'][$k][$n])? $GLOBALS['MODULES_START'][$k][$n] : $def) : $GLOBALS['MODULES_START'][$k] ;
	}
	else
		return '';
}

function get_module_text($n){

	$link_cfg = '<br><p class="right"><a href="index.php?a=form_edit&b='.$n.'" class="btn">edytuj</a></p>';

	if(defined('CONFIGURATION_FILE') && defined('SHOW_VALUES'))
	{
		global $CONFIG_OBJ;
		
		if(isset($CONFIG_OBJ[$n]))
		{
			$d = array();
			$ret_str = '';

			foreach($CONFIG_OBJ[$n] as $v)
			{
				if(
					($n == 'rs485' && $v['typ'] != 'element')
					||
					($n == 'devices')
				)
				{}
				else
				{
					$d['<span class="f-min-min">'.$v['nazwa'].'</span>'] = '<span class="href" style="color:var(--color_text_more);" onclick="sendCmdToelement(\''.$v['nazwa'].'\');"><span class="f-min-min setChangeRed" data-ident-res="'.$v['nazwa'].'" data-ident-res-blink="'.$v['nazwa'].'">x</span></span>';
				}
			}

			$ile = count($d);
			$d1 = array();
			$d2 = array();
			
			if($ile > 5)
			{
				$to = round($ile/2);
				$d1 = array_slice($d, 0, $to, true);
				$d2 = array_slice($d, $to+1, null, true);

				$ret_str = html :: table(array(html :: table($d1) => html :: table($d2)));
			}
			else
				$ret_str = html :: table($d);
			
			return $ret_str . $link_cfg;
		}
		else
			return $link_cfg;
	}
	else
	{
		return get_module_obj($n, 'desc');
	}

}

$main_str = defined('IS_CONTENT')? 'RASPBERRY IHOME CONTROLER<br><img src=\'_img/logo_pi.png\'>' : '<div class=\'center\'>RASPBERRY<br>IHOME<br>CONTROLER</div>' ;

$ratio = defined('IS_CONTENT')?2:1;

$modules_list = array(
	'gpio' => '15,35',
	'i2c' => '17,12',
	'rs485' => '35,5',
	'ports' => '50,0',
	'variables' => '65,5',
	'events' => '85,20',
	'time' => '100,45',
	'boiler_ot' => '85,75',
	'rflink' => '65,90',
	'devices' => '50,80',
	'cameras' => '30,70',
	'zigbee' => '15,72',
	'script' => '10,55',
);



echo '<div style="width:100%; aspect-ratio:'.$ratio.';" id="ricDiagramLayer"></div>';
echo '<div style="display:none;" id="elementsDefLayer">';
echo '<div data-name="'.$main_str.'" data-pos="50,50"></div>';
foreach($modules_list as $k => $v)
	echo '<div data-name="'.get_module_obj($k, 'name', $k).'" data-pos="'.$v.'" data-ico="'.get_module_obj($k, 'ico').'">'.(defined('IS_CONTENT')? get_module_text($k) : '').'</div>';
echo '</div>';


?>

<script>
<?php
echo "var SHOW_VALUES=" . (defined('SHOW_VALUES')?'true':'false') . ';' ;
?>


var x1 = new diagramDesigner("#ricDiagramLayer");
x1.setOption('delayElem', 100);
x1.setOption('lineColor', '#999');
//x1.setFormField('tx1');

var _dgr = 1;
var moreDesc = {};

$('#elementsDefLayer > div').each(function(n){

	let _n = $(this).attr('data-name');
	let _pos = $(this).attr('data-pos').split(',');
	let _desc = $(this).html();
	let _ico = $(this).attr('data-ico');
	//console.log(_n, _pos);
	//console.log(_desc);
	
	if(_ico)
	{
		if(_ico.indexOf('.png') != -1)
			_n = '<span class="module_ico min mgr-10"><img src="'+_ico+'" alt="" title=""></span>' + _n;
		else
			_n = '<span class="module_ico min mgr-10"><i class="fa ' + _ico + '" aria-hidden="true"></i></span>' + _n;
	}

	if(_desc.length > 20 && !SHOW_VALUES)
	{
		moreDesc['moreDescX'+n] = [_n, _desc];
		
		_desc = _desc.substr(0, 100) +'...'
		+ '<div class="right mgt-10"><span class="href link" onclick="box.show(\'div\', \'#moreDescX'+n+'\');">więcej</span></div>';
	}

	x1.addElem({id:_dgr, name:_n, desc :_desc, desc_pos : 'cb', x:parseInt(_pos[0]), y:parseInt(_pos[1])}, _dgr>1? {to:1} : null);

	_dgr ++;
});

for(let a in moreDesc)
	$('body').append(`<div class="none box" id="${a}" style="max-width:80vw;">
		<div class="box_header">${moreDesc[a][0]}</div><div class="box_content">${moreDesc[a][1]}</div></div>`);

$(function(){
	x1.start();
});



</script>


<?php

if(defined('CONFIGURATION_FILE') && defined('SHOW_VALUES'))
echo <<< HTML
	<script>
	function sendCmdToelement(n){
		let _nl = String.fromCharCode(13);
		if(confirm(n + _nl + _nl + 'Wykonać ?'))
			rpih.elemSetAction(n, -1);
	}
	$(function(){rpih.read_all();});
	</script>
HTML;

if(defined('IS_CONTENT'))
echo <<< CSS

<style>

span[data-diagram-co="q-mark"]
	{position:absolute; top:-10px; right:-10px; color:#000; display:inline-block; font-weight:700; background:#ffaa00; border-radius:10px; text-align:center; width:18px; height:18px; border:1px solid #fff;}

div[data-diagram-name=objects] div
	{border:1px solid #eee;background:var(--bg_color_bx); padding:2px 5px; border-radius:5px; color:var(--color_text); max-width:200px; text-align:center; font-size:1.5em;}

div[data-diagram-name=info] > div
	{background:rgba(0,0,0,0.5); padding:5px; margin:-3px 0 0 0; font-size:0.8em; box-sizing:border-box; color:#fff; max-width:200px;}

div[data-diagram-name=infoFull]
	{padding:10px; box-sizing:border-box; background:rgba(0,0,0,0.8);border-radius:15px;}

div[data-diagram-name=infoFull] span
	{display:block; text-align:right; margin-bottom:10px;}
div[data-diagram-name=infoFull] span a
	{display:inline-block; text-align:center; color:#fff; font-size:1.2em; text-decoration:none;
font-weight:700; background:#ff9900; border-radius:20px; width:30px; height:30px; border:1px solid #fff;
	}

div[data-diagram-name=info]
	{z-index:10 !important;}
div[data-diagram-name=infoFull] > div
	{color:#fff; font-size:1.2em;}


@media screen and (max-width: 1000px)
{
	div[data-diagram-name=objects] div
		{font-size:1.2em;}
}
	
@media screen and (max-width: 800px)
{
	div[data-diagram-name=info] div
		{display:none;}	
}

</style>

CSS;

?>

