import os
import sys
import time
from datetime import date

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')


#from lib.rxtx_class import *
#from lib.mk_class import dataX
from _config_top import *
from read_write import readAllElements
from read_write import sendCommand2Element

SQL_WORK = msqlLite(SQL_PATH, 'work')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

#FILE_CONFIG
HEAT_CONFIG = {}

var_temp_zewn = ''
var_temp_wewn = ''
var_co_is_work = ''
var_cmd_co_start = ''
var_cmd_co_stop = ''
var_cmd_co_temp = ''
var_co_is_active = ''
var_co_timer = ''
var_histereza = ''
co_timer = 0

var_cwu_is_work = ''
var_cmd_cwu_start = ''
var_cmd_cwu_stop = ''
var_cmd_cwu_temp = ''
var_cwu_temp = ''
var_cwu_is_active = ''

workVariables = {}
def makeVariables2work():
	global workVariables
	workVariables = readAllElements()

def setInitialData():
	global FILE_CONFIG, HEAT_CONFIG
	global var_temp_zewn, var_temp_wewn, var_co_is_work, var_cmd_co_start, var_cmd_co_stop, var_cmd_co_temp, var_co_is_active, var_histereza
	global var_cwu_is_work, var_cmd_cwu_start, var_cmd_cwu_stop, var_cmd_cwu_temp, var_cwu_temp, var_cwu_is_active, var_co_timer

	HEAT_CONFIG = json_file_get_var(FILE_CONFIG, 'boiler_ot', {})

	var_temp_zewn = var_get_len(HEAT_CONFIG, ['var', 'temp_zewn'], var_get(HEAT_CONFIG, ['var', 'temp_zewn_oth'], '?'))
	var_temp_wewn = var_get_len(HEAT_CONFIG, ['var', 'temp_wewn'], var_get(HEAT_CONFIG, ['var', 'temp_wewn_oth'], '?'))

	var_co_is_work = var_get(HEAT_CONFIG, ['var', 'co_czy_pracuje'], '?')
	var_cmd_co_start = var_get(HEAT_CONFIG, ['cmd', 'co_start'], '?')
	var_cmd_co_stop = var_get(HEAT_CONFIG, ['cmd', 'co_stop'], '?')
	var_cmd_co_temp = var_get(HEAT_CONFIG, ['cmd', 'co_temp'], '')
	var_histereza = var_get_float(HEAT_CONFIG, ['var', 'histereza'], 0)
	var_co_timer = var_get_len(HEAT_CONFIG, ['var', 'co_timer'], '?')

	if var_temp_zewn != '?' and var_temp_wewn != '?' and var_cmd_co_start != '?' and var_cmd_co_stop != '?':
		var_co_is_active = var_get(HEAT_CONFIG, ['var', 'co_czy_aktywny'], '?')
	else:
		var_co_is_active = '?'

	var_cwu_is_work = var_get(HEAT_CONFIG, ['var', 'cwu_czy_pracuje'], '?')
	var_cwu_temp = var_get(HEAT_CONFIG, ['var', 'cwu_temp'], '?')
	var_cmd_cwu_start = var_get(HEAT_CONFIG, ['cmd', 'cwu_start'], '?')
	var_cmd_cwu_stop = var_get(HEAT_CONFIG, ['cmd', 'cwu_stop'], '?')
	var_cmd_cwu_temp = var_get(HEAT_CONFIG, ['cmd', 'cwu_temp'], '')	

	if var_cmd_cwu_start != '?' and var_cmd_cwu_stop != '?' and var_cwu_temp != '?':
		var_cwu_is_active = var_get(HEAT_CONFIG, ['var', 'cwu_czy_aktywny'], '?')
	else:
		var_cwu_is_active = '?'

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def get_temp_ustawienie():
	global HEAT_CONFIG

	pora_dnia = 'noc'
	now = datetime.now()
	hour = now.hour
	min = now.minute	
	week_day = date.today().weekday()+1

	pory_dnia = ['rano', 'dzien', 'wieczor', 'noc']

	conf = var_get(HEAT_CONFIG, ['hours', str(week_day)])

	for pora in pory_dnia:
		_tm = var_get(conf, pora, '')
		if len(_tm) == 5:
			_h = int(_tm[0:2])
			_m = int(_tm[3:])
			if (hour == _h and min >= _m) or hour > _h:
				pora_dnia = pora

	temp = var_get_float(HEAT_CONFIG, ['temp', pora_dnia])
	return [temp, pora_dnia]

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def get_temp_zewn_wewn(variables):
	global HEAT_CONFIG, var_temp_zewn, var_temp_wewn

	if var_get_len(variables, var_temp_zewn, '---', '|') == '---' or var_get_len(variables, var_temp_wewn, '---', '|') == '---':
		return [0, -999]
	else:
		_zew = var_get_float(variables, var_temp_zewn, 0, '|')
		_wew = var_get_float(variables, var_temp_wewn, 20, '|')
		
		if _zew > -40 and _wew > 0 and _wew < 40:
			return [_zew, _wew]
		else:
			return [0, -999]

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def get_temp_krzywa(temp_z):	
	global HEAT_CONFIG
	global SQL_WORK

	conf = var_get(HEAT_CONFIG, 'kg')

	s = int(var_get(conf, 's'))
	n = int(var_get(conf, 'n'))

	if temp_z > 20:
		temp = 20
	else:
		t = math.log10((-temp_z + 41)) * n + s;
		t = round(t, 2)
		temp = t if t<=90 else 90

	SQL_WORK.setVal('boiler_ot', 'temp_curve', temp)
	return temp

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def check_boost():
	global SQL_WORK
	
	strBoost = SQL_WORK.getVal('boiler_ot', 'boost_start', '')
	
	if len(strBoost) >= 1:# and strBoost.find(':') != -1:
		#_a, _b = strBoost.split(':')
		_a, _b = strBoost.split(':') if strBoost.find(':') else (strBoost+':').split(':')
		_ia = as_number(_a)
		_ib = as_number(_b) * 60#bo przychodzi w minutach i nalezy pomnozyc
		
		SQL_WORK.delVal('boiler_ot', 'boost_start')
		
		if _ia > 0:
			SQL_WORK.setValArr('boiler_ot', 'boost_param', [str(_ia), mdate.get_add('h:m', _ib)], ';')
			return [True, _ia]
		else:
			SQL_WORK.delVal('boiler_ot', 'boost_param')
	else:
		temp, do_kiedy = SQL_WORK.getValArr('boiler_ot', 'boost_param', ['0', '---'], ';')
		temp = as_number(temp)
		
		if do_kiedy != '---' and temp > 0:			
			#print(temp, do_kiedy)

			if mdate.time_diff(do_kiedy, mdate.get('h:m')) <= 0:
				SQL_WORK.delVal('boiler_ot', 'boost_param')
			else:
				return [True, temp]

	return [False, 0]

def check_boost_oldddddddddddddd():
	global DIR_QUICK_MEM
	
	fName = DIR_QUICK_MEM + '_boiler_ot_co_boost.cmd'
	fNameT = DIR_QUICK_MEM + '_boiler_ot_co_boost_time.json'
	
	strCmd = file_read(fName)
	sec = 2
	
	if len(strCmd) >= 3 and strCmd.find(':') != -1:
		_a, _b = strCmd.split(':')
		_ia = int(_a)
		_ib = int(_b) * 60#bo przychodzi w minutach i nalezy pomnozyc
		
		file_del(fName)
		
		if _ia > 0:
			json_file_save(fNameT, {'do_kiedy' : mdate.get_add('h:m', _ib), 'temp' : _ia})
			return [True, _ia]
		else:
			file_del(fNameT)
	else:
		obj = json_file_get(fNameT)
		
		temp = var_get_int(obj, 'temp')
		do_kiedy = var_get(obj, 'do_kiedy', '00:00')

		#if do_kiedy == date_get('h:m'):# or  mdate.time_diff(d1, d2)::
		if mdate.time_diff(do_kiedy, mdate.get('h:m')) <= 0:
			file_del(fNameT)
		else:
			return [True, temp]

	return [False, 0]

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def send_cmd2element(cmd):
	global PLATFORM
	
	if cmd.find('=') > 0:
		a, b = cmd.split('=')
		sendCommand2Element(a, b)
		if PLATFORM == 'win':
			print('send_cmd_to', a, b)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def co_timer_action(is_start = False):
	global var_co_timer, co_timer
	if is_start:
		if co_timer == 0:
			co_timer = int(datetime.now().timestamp())
	else:
		if co_timer > 0:
			end = int(datetime.now().timestamp())			
			#print(var_co_timer, end-co_timer)
			if var_co_timer != '?':
				minutes = int((end-co_timer)/60)
				send_cmd2element(var_co_timer + '=' + str(minutes))
			co_timer = 0

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def send_cmd_co_temp(temp):
	global var_cmd_co_temp
	#if len(var_cmd_co_temp) > 0:
	send_cmd2element(var_cmd_co_temp + "=" + str(int(temp)))

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def send_cmd_co_on_off(is_start:bool):
	global var_cmd_co_start, var_cmd_co_stop, var_cmd_co_temp
	
	if is_start:
		send_cmd2element(var_cmd_co_start)
	elif is_start==False:
		send_cmd2element(var_cmd_co_stop)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def send_cmd_cwu_temp(temp):
	global var_cmd_cwu_temp
	send_cmd2element(var_cmd_cwu_temp + "=" + str(int(temp)))

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def send_cmd_cwu_on_off(is_start:bool):
	global var_cmd_cwu_start, var_cmd_cwu_stop
	
	if is_start:
		send_cmd2element(var_cmd_cwu_start)
	elif is_start==False:
		send_cmd2element(var_cmd_cwu_stop)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
temp_co_wyslana = 0
tryb_co = -1



def sprawdz_co(isWorkingChek = False):
	global tryb_co, var_co_is_active, var_co_is_work, var_histereza, workVariables, temp_co_wyslana

	variables_all =  workVariables
		
	is_working = var_get_int(variables_all, var_co_is_work, 0) == 1

	if var_get_int(variables_all, var_co_is_active, 0) == 1:		
		
		temp_zewn, temp_wewn = get_temp_zewn_wewn(variables_all)

		temp_nastawiona, pora_dnia = get_temp_ustawienie()
		temp_ogrzewania = get_temp_krzywa(temp_zewn)

		boost_is, boost_temp = check_boost()
		#print(boost_is, boost_temp)

		if boost_is and boost_temp > 0:
			temp_ogrzewania = boost_temp
			temp_nastawiona = temp_wewn + var_histereza

		#print('zewn: '+str(temp_zewn), 'wewn: '+str(temp_wewn), 'nast: '+str(temp_nastawiona), 'krzywa: '+str(temp_ogrzewania))
		if temp_wewn != -999 or boost_is == True: #aby nie pobierał głupot, lub jest boost
			if temp_wewn < temp_nastawiona and tryb_co != 1:#zalacza piec
				tryb_co = 1
				#print('temp_ogrzewania', temp_ogrzewania)
				send_cmd_co_on_off(True)
				send_cmd_co_temp(temp_ogrzewania)
				co_timer_action(True)
				add2log('boiler_ot', 'co start', {'pora_dnia':pora_dnia, 'zewn':temp_zewn, 'wewn':temp_wewn, 'nast':temp_nastawiona, 'temp_krzywa':temp_ogrzewania}, 'red')
			elif temp_wewn >= temp_nastawiona+var_histereza and tryb_co != 0:#wylacza piec
				tryb_co = 0
				send_cmd_co_on_off(False)
				co_timer_action(False)
				add2log('boiler_ot', 'co stop', {'pora_dnia':pora_dnia, 'zewn':temp_zewn, 'wewn':temp_wewn, 'nast':temp_nastawiona, 'temp_krzywa':temp_ogrzewania}, 'green')
			elif isWorkingChek and is_working == False and tryb_co == 1:#powino grzac a nie grzeje
				send_cmd_co_on_off(True)
				add2log('boiler_ot', 'co start-reply', {'pora_dnia':pora_dnia, 'zewn':temp_zewn, 'wewn':temp_wewn, 'nast':temp_nastawiona, 'temp_krzywa':temp_ogrzewania}, 'red')
			elif isWorkingChek and is_working == True and tryb_co == 0:#powinien sie wylaczyc
				send_cmd_co_on_off(False)
				add2log('boiler_ot', 'co stop-reply', {'pora_dnia':pora_dnia, 'zewn':temp_zewn, 'wewn':temp_wewn, 'nast':temp_nastawiona, 'temp_krzywa':temp_ogrzewania}, 'green')

			if (isWorkingChek or temp_co_wyslana != temp_ogrzewania) and is_working and tryb_co == 1:
				send_cmd_co_temp(temp_ogrzewania)
				temp_co_wyslana = temp_ogrzewania + 0

	else:
		if tryb_co != 0:
			tryb_co = 0
			send_cmd_co_on_off(False)
			co_timer_action(False)
			add2log('boiler_ot', 'co off', {}, 'green')
		elif isWorkingChek and tryb_co == 0 and is_working:
			send_cmd_co_on_off(False)
			co_timer_action(False)
			add2log('boiler_ot', 'co off', {}, 'green')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

temp_wody_akt = 0;
tryb_cwu = -1

def sprawdz_cwu(isWorkingChek = 0):
	global tryb_cwu, var_cwu_is_active, var_cwu_is_work, var_cwu_temp, temp_wody_akt, workVariables

	variables_all =  workVariables
	
	is_working = var_get_int(variables_all, var_cwu_is_work, 0) == 1

	if var_get_int(variables_all, var_cwu_is_active, 0) == 1:

		temp_wody = var_get_int(variables_all, var_cwu_temp, 0)

		if tryb_cwu != 1:
			tryb_cwu = 1
			send_cmd_cwu_on_off(True)
			add2log('boiler_ot', 'cwu on', {'temp' : temp_wody, 'akt_temp' : temp_wody_akt}, 'red')
		elif isWorkingChek == 1 and is_working == False and tryb_cwu == 1:#powino grzac a nie grzeje
			send_cmd_cwu_on_off(True)
		elif isWorkingChek == 1 and is_working == True and tryb_cwu == 0:#powinien sie wylaczyc
			send_cmd_cwu_on_off(False)
		
		if temp_wody > 0 and tryb_cwu == 1:
			if temp_wody != temp_wody_akt and isWorkingChek==0:
				temp_wody_akt = temp_wody
				send_cmd_cwu_temp(temp_wody)
			elif isWorkingChek == 2:
				send_cmd_cwu_temp(temp_wody)

	else:
		if tryb_cwu != 0:
			tryb_cwu = 0
			send_cmd_cwu_on_off(False)
			add2log('boiler_ot', 'cwu off', {}, 'green')
		elif isWorkingChek == 1 and tryb_cwu == 0 and is_working:
			send_cmd_cwu_on_off(False)

if PLATFORM == 'rpi':	
	time.sleep(6)
	print('boiler_ot_start')

setInitialData()

'''

ot.setBoilerStatus(true or false);

	ot.setBoilerTemperature(64);

ot.setDHWSetpoint(40);
ot.getDHWTemperature();
'''


'''now = datetime.now()
		
		for k, v in self.obj.items():
			if k not in self.obj_lock or (k in self.obj_lock and self.obj_lock[k] == 0):
				if v['type'] == 't':
					if now.strftime("%H:%M") == v['param_s']:
						return k
'''

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'''
print(12, get_temp_krzywa(12))
print(0, get_temp_krzywa(0))
print(-12, get_temp_krzywa(-12))
print(-20, get_temp_krzywa(-20))

time.sleep(1000)
'''

if PLATFORM == 'win':
	print('boiler_ot start')

makeVariables2work()

x = 0
y = 0

try:
	
	while 1: 	

		x = x + 1

		if x == 30:
			sprawdz_co(True)
			sprawdz_cwu(1)
		elif x % 2 == 0:
			sprawdz_co()
			sprawdz_cwu()
		
		if x % 5 == 0:
			makeVariables2work()

		if x == 60:#co minute
			setInitialData()
			x = 0
			sys_workingModules.set('boiler_ot')
			y = y+1

		if y == 10:#10 minut
			y = 0
			sprawdz_cwu(2)

		
		time.sleep(1)
 
except KeyboardInterrupt:

	#if RSE:
	#	RSE.stop()

	print('Koniec') 
