import sys
import os
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from _config_top import *

SQL = msqlLite(SQL_PATH)
OBJ_DEVICES = []

errDevices = connErr(2)
current_device = -1

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def devicesTryAdd2globalErr():
	global errDevices, sys_conn_error
	
	err = errDevices.getErr()
	
	if len(err) > 0:
		sys_conn_error.set('devices', err)
	else:		
		sys_conn_error.set('devices', '')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mkObjDevices():
	global FILE_CONFIG, OBJ_DEVICES, errDevices, current_device
	
	d = json_file_get_var(FILE_CONFIG, 'devices', {})

	current_device = -1

	OBJ_DEVICES = []
	for a in d:
		if a['typ'] != 'comp' and a['typ'] != 'camera':
			if var_get_int(a, 'aktywny') == 1:
				errDevices.addDevice(a['nazwa'], var_get_len(a, 'opis', a['nazwa']))
				OBJ_DEVICES.append(a)
			else:
				errDevices.removeDevice(a['nazwa'])

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk2updateDevices(is_all = False):
	global SQL, OBJ_DEVICES, current_device, errDevices

	current_device = current_device + 1

	if current_device == len(OBJ_DEVICES):
		current_device = 0

	_n = OBJ_DEVICES[current_device]['nazwa']
	
	errDevices.setPing(_n)
	is_conn, obj = devices_do.read_all(OBJ_DEVICES, _n)
	
	if is_conn:
		errDevices.setReply(_n)
	
	SQL.setValues('devices', obj)
	

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

if PLATFORM == 'win':
	print('devices start')

try:
	
	sys_workingModules.set('devices')

	mkObjDevices()
	
	sec = 0
	
	while True:

		# co dwie minuty
		if sec % 120 == 0:
			mkObjDevices()
			mk2updateDevices(True)
		elif sec % 2 == 0: #10 sekund
			mk2updateDevices(False)
		
		if sec % 10 == 0: #10 sekund
			devicesTryAdd2globalErr()

		if sec % 60==0:
			sys_workingModules.set('devices')
		
		sec = sec + 1

		if sec == 3600:
			sec = 1			

		time.sleep(1)

except KeyboardInterrupt:
	print('Koniec')