import os
import sys
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from lib.rxtx_class import *
from lib.mk_class import dataX
from _config_top import *

if PLATFORM != 'win':
	import smbus
	i2c = smbus.SMBus(1)
else:
	i2c = {}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

SQL = msqlLite(SQL_PATH)
SQL_REPLY = msqlLite(SQL_PATH, 'reply')

I2C_OBJ = {}
I2C_OBJ_ELEM = {}

DATA_VAR = {}#dataX(FILE_I2C_DATA)
DATA_MEM = {}
errDevices = connErr(5)
current_nr = 0

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def config_obj_start(is_start = False):
	global FILE_CONFIG
	global I2C_OBJ
	global I2C_OBJ_ELEM
	global current_nr
	global DATA_VAR
	global errDevices

	I2C_OBJ = {}
	I2C_OBJ_ELEM = {}

	if is_start:
		current_nr = 0

	config_obj_i2c = json_file_get_var(FILE_CONFIG, 'i2c')

	for a in config_obj_i2c:
		n = a['nazwa']

		if a['typ'] == 'definicja' and len(a['adres'])>0 and var_get_int(a, 'aktywny', 0) == 1:
			a['addr'] = eval(a['adres'])	
			I2C_OBJ[n] = a
			
			DATA_VAR[n] = ''
			errDevices.addDevice(n, var_get_len(a, 'opis', n))

	for a in config_obj_i2c:
		n = a['nazwa']

		if a['typ'] != 'definicja' and a['definicja'] in I2C_OBJ and var_get_int(a, 'aktywny', 0) == 1:
			I2C_OBJ_ELEM[n] = a
			#DATA_VAR.set(n, '')
			DATA_VAR[n] = ''

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def i2cTryAdd2globalErr():
	global errDevices
	
	err = errDevices.getErr()

	if len(err) > 0:
		sys_conn_error.set('i2c', err)
	else:		
		sys_conn_error.set('i2c', '')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def check2do():	
	#global FILE_I2C2DO_DATA
	global SQL
	
	#d = json_file_get(FILE_I2C2DO_DATA)
	d = SQL.getValues('i2c_cmd')
	
	if len(d) > 0:
		_k, _v = d.popitem()

		if _k in I2C_OBJ:
			i2c_data_set(I2C_OBJ[_k]['addr'], _v);
		elif _k in I2C_OBJ_ELEM:
			n = I2C_OBJ_ELEM[_k]['definicja']
			i2c_data_set(I2C_OBJ[n]['addr'], _v);

		#json_file_save(FILE_I2C2DO_DATA, d)
		SQL.delVal('i2c_cmd', _k)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def current_get():
	global current_nr	
	x = -1
	for a in I2C_OBJ:
		x = x+1
		if x == current_nr:
			current_nr = current_nr+1
			if current_nr == len(I2C_OBJ):
				current_nr=0
			return I2C_OBJ[a]
	return False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def ConvertStringsToBytes(src): 
	converted = [] 
	for b in src: 
	    converted.append(ord(b))
	return converted

# - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def i2c_data_get(address):
	global i2c
	txt = ""

	try:
		data = i2c.read_i2c_block_data(address, 0)

		for i in range(len(data)):
			#if data[i] != 255:
			if data[i] >= 32 and data[i] <= 126:
				txt += chr(data[i])
	except:
		txt = ""

	return txt.replace(' ', '')
	#.encode('utf-8')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def i2c_data_set(address, txt):
	global DATA_MEM

	try:
		BytesToSend = ConvertStringsToBytes(txt) 
		i2c.write_i2c_block_data(address, 0x01, BytesToSend);
		
		DATA_MEM[fn.date_full(True)] = '>&nbsp;' + fn.simple_chars(txt)
		
		return True
	except:
		return False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk_i2c_current_device():
	#global CONFIG_OBJ
	global I2C_OBJ
	global I2C_OBJ_ELEM	
	global DATA_VAR
	global DATA_MEM
	global errDevices
	
	act = current_get()

	if act:

		errDevices.setPing(act['nazwa'])
		
		txt = i2c_data_get(act["addr"])

		n = act['nazwa']
		#print(n)

		#txt = file_read('_a.txt', '')
		
		if len(txt) > 0:
			
			#DATA_VAR.set(n, txt, True)	
			DATA_VAR[n] = txt
			errDevices.setReply(act['nazwa'])

			for em in I2C_OBJ_ELEM:
				a = I2C_OBJ_ELEM[em]

				if a['definicja'] == n:	
					if len(a['wyrazenie']['nie'])>0 and str(txt).find(a['wyrazenie']['nie']) != -1:
						#DATA_VAR.set(a['nazwa'], 0, True)
						DATA_VAR[a['nazwa']] = 0
					elif len(a['wyrazenie']['tak'])>0 and str(txt).find(a['wyrazenie']['tak']) != -1:
						#DATA_VAR.set(a['nazwa'], 1, True)
						DATA_VAR[a['nazwa']] = 1
					elif len(a['number_val']['reg'])>0 and len(txt)>=2:
						
						if len(a['number_val']['proc_min'])>0 and len(a['number_val']['proc_max'])>0:
							vv = value.expression(txt, a['number_val']['reg'], -12345, [a['number_val']['proc_min'], a['number_val']['proc_max']])
						else:
							vv = value.expression(txt, a['number_val']['reg'], -12345)

						if vv != -12345:
							#DATA_VAR.set(a['nazwa'], vv, True)
							DATA_VAR[a['nazwa']] = vv

			DATA_MEM[fn.date_full(True)] = '<&nbsp;' + fn.simple_chars(txt)

	check2do()	

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

if PLATFORM == 'win':
	print('i2c start')

config_obj_start(True);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

x = 0

try:
	
	while 1:

		x = x + 1

		if x % 10 == 0:
			SQL.setValues('i2c', DATA_VAR)
			i2cTryAdd2globalErr()

		if x % 20 == 0:
		#if x % 10 == 0:
			#co 2 sekundy
			mk_i2c_current_device()
			DATA_MEM = SQL_REPLY.setSortLimit('i2c', DATA_MEM, 20)

		if x == 600:#co minute
		#if x == 22:
			x = 0
			sys_workingModules.set('i2c')
			config_obj_start()
		
		time.sleep(0.1)
 
except KeyboardInterrupt:

	print('Koniec') 