import os
import sys
import json
import platform
from socket import timeout
import socket
import struct
import subprocess
import re
import time
from datetime import datetime, timedelta

#PLATFORM = 'win' if platform.system() == 'Windows' else 'rpi'

import urllib.request
import base64

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class mdate:
	def get(f = ''):
		now = datetime.now()
		if f == 'h:m':
			return now.strftime("%H:%M")
		else:
			return now.strftime("%Y-%m-%d %H:%M:%S")

	def get_add(f = '', secs=0):
		now = datetime.now() + eval('timedelta(seconds = '+str(secs)+')')
		if f == 'h:m':
			return now.strftime("%H:%M")
		else:
			return now.strftime("%Y-%m-%d %H:%M:%S")

	def time_diff(d1, d2):
		if len(d1) == 5 and len(d2) == 5:
			try:
				h1 = int(d1[0:2])
				m1 = int(d1[3:])
				h2 = int(d2[0:2])
				m2 = int(d2[3:])
				
				if h1 == h2:
					return m1-m2
				elif h1 > h2:
					return (h1-h2) * 60 + m1-m2
				elif h2 > h1:
					return (h1-h2) * 60 + m1-m2

			except Exception as e:
				return 0
		else:
			return 0

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def uniqid(a='', b=''):
	return a + str(time.time()) + b

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def check_step_number(v, prev, step=1, df = 0):

	nr = as_number(v, -987654321, True)
	prev = as_number(prev, -987654321, True)	
	
	if nr != -987654321:
		if prev != -987654321:
			if step ==0:
				return nr
			elif nr > prev:
				return prev + step
			elif nr < prev:
				return prev - step
			else:
				return nr
		else:
			return nr;
	else:
		if prev != -987654321:
			return prev
		else:
			return df

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class step_number:
	obj = {}
	def check(n, v, step, df=0):

		val = as_number(v, -987654321, True)
		_min = datetime.now().minute; #second #minute
		
		if val != -987654321:
			if n in step_number.obj:			
				if step_number.obj[n]['m'] != _min:
					prev = step_number.obj[n]['v']
					
					if val > prev:
						ret =  prev + step
					elif val < prev:
						ret = prev - step
					else:
						ret = val

					step_number.obj[n] = {'v':ret, 'm':_min}
					return ret
				else:
					return step_number.obj[n]['v']
			else:
				step_number.obj[n] = {'v':val, 'm':_min}
				return val
		else:
			return df

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk_php(file='index.php', cmd='', cmdAd = '', cmdAd1 = ''):
	
	#sudo php /var/www/html/ihome/index.php read_configuration
	#command = ['ping', param, '1', host]	
	#command = ['sudo', 'php', '/var/www/html/ihome/index.php', cmd]

	if len(cmdAd) > 0:
		cmd = cmd + ' ' + cmdAd

	if len(cmdAd1) > 0:
		cmd = cmd + ' ' + cmdAd1
	#print(platform.platform().lower()) / dom: windows-10-10.0.19045-sp0
	#print(platform.platform().lower())
	if platform.system().lower()=='windows':
		pth = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '../../'))+"/"

		ver = 'php8.0.13' if platform.platform().lower().find('19045')!=-1 else 'php8.2.0'
		#php_path = 'c:/wamp64/bin/php/php7.4.33/php.exe' if platform.platform().lower().find('windows-10') != -1 else 'c:/php70/php.exe'
		php_path = 'c:/wamp64/bin/php/'+ver+'/php.exe' if platform.platform().lower().find('windows-10') != -1 else 'c:/php70/php.exe'

		#proc = subprocess.Popen('c:/php70/php.exe '+pth+''+file+' ' + cmd+'', shell=True, stdout=subprocess.PIPE)
		proc = subprocess.Popen(php_path + ' '+pth+''+file+' ' + cmd+'', shell=True, stdout=subprocess.PIPE)		
	else:
		proc = subprocess.Popen("php /var/www/html/ihome/"+file+" " + cmd, shell=True, stdout=subprocess.PIPE)

	return proc.stdout.read().decode()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk_python (file, *argv):
	#print('mk_python', file, argv)
	if platform.system().lower()=='windows':
		pth = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '../'))+"/"
		command = ['python', pth + '' + file + '.py']
		
		for arg in argv: 
			command.append(arg)
		
		return subprocess.call(command, stderr=subprocess.DEVNULL)
	else:
		command = ['sudo', 'python3', '/var/www/html/ihome/pt/' + file + '.py']
		
		for arg in argv: 
			command.append(arg)

		return subprocess.call(command, stderr=subprocess.DEVNULL)
		#, stdout=subprocess.DEVNULL, stderr=subprocess.STDOUT

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_read11111(fName, defStr=""):
	if os.path.isfile(fName):
		try:
			with open(fName, "r") as f:
				s = f.read()
				f.close()
		except Exception as e:
			s = defStr
		return s
	else:
		return defStr

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_save1111(fName, txtStr):

	try:
		fileHandle = open(fName, "w")
		fileHandle.write(txtStr)
		fileHandle.close()	
		return True	
	except Exception as e:
		return False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_last_save(file):
	try:
		a = datetime.now()
		b = datetime.fromtimestamp(os.path.getmtime(file))
		return int((a-b).total_seconds())
	except Exception as e:
		return -1


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_read(fName, defStr=""):
	if os.path.isfile(fName):		
		try:
			with open(fName, "r") as f:
				s = f.read()
				f.close()
		except Exception as e:
			s = defStr
		return s
	else:
		return defStr

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_save(fName, txtStr):

	try:
		fileHandle = open(fName, "w")
		fileHandle.write(txtStr)
		fileHandle.close()
		return True	
	except Exception as e:
		return False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_del(fName):
	if os.path.exists(fName):
		os.remove(fName)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def file_create_if_no(fName, content=""):
	if os.path.isfile(fName) == True:
		return False
	else:
		f = open(fName, 'w')
		f.write(content)
		f.close()
		return True

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def json_file_get (fName, defa={}):

	if os.path.isfile(fName) == True:
		strF = file_read(fName)
		if is_json(strF):
			js = json.loads(strF)
			return js
		else:
			return defa
	else:
		return defa

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def json_file_get_var (fName, n, defa={}):

	d = json_file_get(fName, {})
	return var_get(d, n, defa)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def json_file_add_var (fName, n, v):

	d = json_file_get(fName, {})
	d[n] = v
	json_file_save(fName, d)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def json_file_save(fName, obj, add = False):

	if add:
		ex = json_file_get(fName)
		for a in obj:
			ex[a] = obj[a]
		return file_save(fName, json.dumps(ex))
	else:
		return file_save(fName, json.dumps(obj))

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def is_json(myjson):
	try:
		json_object = json.loads(myjson)
	except ValueError as e:
		return False
	return True

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get(obj, n, de = False, pix = '.'):
	# is dict - obiekt
	#str - string
	#list - array

	nt = type(n)

	if nt is str:

		#ps = n.find(pix)
		#if ps > 0:
		#	n1 = n[:ps]
		#	n2 = n.replace(n1+pix, '')
		#	obj = var_get(obj, n1, de)
		#	n=n2	

		while (ps := n.find(pix)) > 0:
			obj = var_get(obj, n[:ps], {}, pix)
			n = n[ps+1:]

	elif nt is list:
		obj = var_get(obj, n[0], de)
		if len(n) == 2:
			n = n[1]
		else:
			del n[0]

	t = type(obj)
	
	if t is dict and n in obj:
		return obj[n]
	elif t is list and n in obj:
		return obj[n]
	elif t is list:
		try:
			return obj[int(n)]
		except:
			return de
	else:
		return de

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get_len(a, b, c = '', d = '.'):
	x = var_get(a, b, c, d)
	return x if len(str(x))>0 else c

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get_int(a, b, c = 0, d = '.'):
	try:
		return int(var_get(a, b, c, d))
	except:
		return c

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get_float(a, b, c = 0, d = '.'):
	try:
		return float(var_get(a, b, c, d))
	except:
		return c

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get_by(obj, n, v, de = False):
	for a in obj:
		if a[n] == v:
			return a
	
	return de;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def var_get_by_val(obj, v, de = False):
	for a in obj:
		if obj[a] == v:
			return a
	
	return de;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def is_eq_int(obj, n, val):
	_v = int(var_get(obj, n, -987654))
	return True if _v == int(val) else False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def as_number(v, df = 0, force_float = False):
	try:
		ui = float(v) if force_float else int(v)
		return ui
	except Exception as e:
		try:
			ui = float(v)
			return ui
		except Exception as e:
			return df	

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def obj_get_diffirence(o1, o2):
	ret = {}
	for a in o1:
		if a in o2:
			if o1[a] != o2[a]:
				ret[a] = o1[a]
		else:
			ret[a] = o1[a]

	return ret

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class obj:
	
	def rm_keys(obj, keys):
		ret = {}
		for a in obj:
			if a not in keys:
				ret[a] = obj[a]
		return ret

	def key_by_val(obj, val, d_ret = False):

		for a in obj:
			if obj[a] == val:
				return a

		return d_ret

	def get_by_val(obj, n, v, _def = {}):
		for a in obj:
			if obj[a][n] == v:
				return obj[a]

		return _def


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def obj_merge(o1, o2, pref=''):
	ret = {}

	for a in o1:
		ret['' + a] = o1[a]

	for a in o2:
		ret[pref + a] = o2[a]
	
	return ret

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class arr:
	def list_by_n(obj, n):
		ret = []
		for a in obj:
			ret.append(var_get(a, n))
		return ret
	def get_by_val(obj, k, v):
		ret = []
		for a in obj:
			if a[k] == v:
				ret.append(a)
		return ret		

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def http_get(url, tm_out=3, ret_type='', options = {}):
	try:
		req = urllib.request.Request(url)

		if type(options) is dict:

			auth = var_get(options, 'auth')
			if auth and type(auth) is list and len(auth) == 2:
				credentials = ('%s:%s' % (auth[0], auth[1]))
				encoded_credentials = base64.b64encode(credentials.encode('ascii'))
				req.add_header('Authorization', 'Basic %s' % encoded_credentials.decode("ascii"))

		response = urllib.request.urlopen(req, timeout=tm_out).read()

		if ret_type != 'img' and ret_type != 'image':
			response = response.decode('utf-8')
		
		if ret_type == 'json':
			ret_json = json.loads(response) if is_json(response) else {}
			return [True, ret_json]
		else:
			return [True, response]

	except Exception as e:
		return [False, str(e).replace('<', '').replace('>', '')]

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def http_post(url, obj, tm_out=3):
	try:
		data = urllib.parse.urlencode(obj).encode()
		req = urllib.request.Request(url, data=data)
		response = urllib.request.urlopen(req, timeout=tm_out).read()

		response = response.decode('utf-8')
		
		return [True, response]

	except Exception as e:
		return [False, str(e).replace('<', '').replace('>', '')]

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def ping_host(host):
	"""
	Returns True if host (str) responds to a ping request.
	Remember that a host may not respond to a ping (ICMP) request even if the host name is valid.
	"""

	# Option for the number of packets as a function of
	param = '-n' if platform.system().lower()=='windows' else '-c'

	# Building the command. Ex: "ping -c 1 google.com"
	command = ['ping', param, '1', host]

	return subprocess.call(command, stdout=subprocess.DEVNULL, stderr=subprocess.STDOUT) == 0

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def wake_up_on_lan(macaddress, broadcast_addr = '192.168.1.255', wake_up_port = 7):
	if len(macaddress) == 12:
		pass
	elif len(macaddress) == 12 + 5:
		sep = macaddress[2]
		macaddress = macaddress.replace(sep, '')
	else:
		return false

	# Pad the synchronization stream.
	data = ''.join(['FFFFFFFFFFFF', macaddress * 20])
	send_data = b''
	
	# Split up the hex values and pack.
	for i in range(0, len(data), 2):
		send_data = b''.join([send_data, struct.pack('B', int(data[i: i + 2], 16))])

	# Broadcast it to the LAN.
	sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	sock.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
	sock.sendto(send_data, (broadcast_addr, wake_up_port))
	return True