from datetime import datetime
from lib.functions import *
import time
import re

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class blockEvent:	
	def __init__(self):

		self.obj = {}
		self.objSeconds = {}
		#self.objTime = {}
		self.timeTick = 1
	
	def check(self, n):

		if n in self.objSeconds:
			if self.objSeconds[n] > 0:
				return 2

		if var_get(self.obj, n) == True:
			return 1
		
		return 0
	
	def add(self, n, is_block, t = ""):

		if is_block:	
			self.obj[n] = True;

		if type(t) is str and len(t) == 5 and t.find(':') > 0:
			_tmppadadasd = 1
		elif type(t) is str and len(t) > 0 and int(t) > 0:
			self.objSeconds[n] = int(t) * (1/self.timeTick)
		elif type(t) is int and t > 0:
			self.objSeconds[n] = t * (1/self.timeTick)
		else:
			self.objSeconds[n] = 0
		'''
		if type(t) is str and len(t) > 0 and int(t) > 0:
			self.objSeconds[n] = int(t) * (1/self.timeTick)
		elif type(t) is int and t > 0:
			self.objSeconds[n] = t * (1/self.timeTick)
		else:
			self.objSeconds[n] = 0
		'''

	def delete(self, n):
		
		if n in self.obj:
			del self.obj[n]
	
	def tick(self):

		for k, v in self.objSeconds.items():
			if v > 0:
				self.objSeconds[k] = v - 1

	def setTick(self, t):
		self.timeTick = t

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class evTime:
	def __init__(self):	
		self.obj = {}
		self.obj_lock = {}
		self.reset()	
	
	def reset(self):	
		self.obj = {}	
	
	def addEvery(self, n, p):	
		self.add('e', n, p)	
	
	def addTime(self, n, p):	
		self.add('t', n, p)	
	
	def add(self, t, n, p):	
		if t == 'e':
			self.obj[n] = {'type':t, 'param_s' : int(p), 'param' : int(p)}
		elif t == 't':
			p1 = self.mkadtm(p)
			self.obj[n] = {'type':t, 'param_s' : p, 'param_s1' : p1, 'param' : 0}	
	
	def update(self, n, p):		
		if n in self.obj:
			if self.obj[n]['type'] == 'e':
				self.obj[n]['param_s'] = int(p)
			else:
				self.obj[n]['param_s'] = p
				self.obj[n]['param_s1'] = self.mkadtm(p)

	def lock(self, n, v):
		self.obj_lock[n] = v

	def check(self):

		for k, v in self.obj_lock.items():
			if v > 0:
				self.obj_lock[k] = v - 1

		now = datetime.now()
		
		for k, v in self.obj.items():
			if k not in self.obj_lock or (k in self.obj_lock and self.obj_lock[k] == 0):
				if v['type'] == 't':
					if now.strftime("%H:%M") == v['param_s'] or now.strftime("%H:%M") == v['param_s1']:
						return k
			
				elif v['type'] == 'e':		
					self.obj[k]['param'] = self.obj[k]['param'] - 1
					if self.obj[k]['param'] == 0:
						self.obj[k]['param'] = self.obj[k]['param_s'];
						return k

		return False

	def mkadtm(self, t):
		_a = as_number(t[3:4])
		_b = as_number(t[4:5])
		
		if _b+1 == 10:
			_a=_a+1
			_b=0
			if _a == 6:
				_a = 5
				_b = 8
		else:
			_b = _b+1

		return t[0:3] + str(_a) + str(_b)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class sensors:
	def __init__(self, file):
		self.file = file
		self.obj = json_file_get(self.file)
		self.current = 0
		self.configObj = []

	def addSensor(self, n, o):
		self.configObj.append({'nazwa' : n, 'obj' : o})
		
	def get(self, n):
		return var_get(self.obj, n, 0)

	def get2update(self):
		if len(self.configObj) > 0:
			return self.configObj[self.current]['obj']
		else:
			return False
	
	def update(self, temp):
		n = self.configObj[self.current]['nazwa']
		self.obj[n] = temp
		
		self.current = self.current + 1
		if self.current == len(self.configObj):
			self.current = 0;

	def save(self):
		json_file_save(self.file, self.obj)			

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class pwmControl:
	def __init__(self):
		self.obj = []
	def add(self, n, o):
		o = {'nazwa' : n, 'obj' : o, 'is_on' : False, 'fill' : 0}
		self.obj.append(o)
	def check(self, setObj):
		for k in range(len(self.obj)):
			v = self.obj[k]
			currentSet = var_get(setObj, v['nazwa'])
			if currentSet != False:
				if currentSet[0] == 1:
					if v['is_on'] == 0:
						self.obj[k]['is_on'] = 1
						self.obj[k]['fill'] = currentSet[1]
						return {'action' : 'start', 'obj' : v['obj'], 'fill' : currentSet[1]}
					elif currentSet[1] != v['fill']:
						self.obj[k]['fill'] = currentSet[1]
						return {'action' : 'fill', 'obj' : v['obj'], 'fill' : currentSet[1]}
				else:
					self.obj[k]['is_on'] = 0
					return {'action' : 'stop', 'obj' : v['obj']}
	
		return False

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class dataX:	
	def __init__(self, file, n = False, defa={}):
		self.file = file		
		self.n = n;
		self.defa = defa
		
		self.refresh()

	def refresh(self):
		ob = json_file_get(self.file, self.defa)
		
		if self.n:
			self.obj = var_get(ob, self.n, self.defa)
		else:
			self.obj = ob		
	
	def set(self, n, v, is_save = False):
		if n == False:
			self.obj = v;
		else:
			self.obj[n] = v
		
		if is_save:
			self.save()

	def get(self, n=False, df=False):
		if n == False:
			return self.obj
		else:
			return var_get(self.obj, n, df)
	
	def save(self):
		ob = json_file_get(self.file);
		
		if self.n:	
			ob[self.n] = self.obj
		else:
			ob = self.obj
		#print('dataX', 'save', ob)
		json_file_save(self.file, ob)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk_replaceString2Values(txt, values):	
	
	try:
		ile = 0
		while True and ile < 10:
			fn = re.search('\$([a-z_0-9\.]{1,})', txt)
			if fn != None:
				g = fn.group()
				vn = g[1:]
				v = var_get(values, vn, '0', '~')		
				txt = txt.replace(g, str(v))
			else:
				break
			ile = ile + 1
	except Exception:
		pass

	return txt

def mk_replaceString2Values_old_ddddddd(txt, values):	

	try:
		fn = re.search('\$([a-z_0-9]{1,})', txt)
		if fn != None:

			g = fn.group()
			vn = g[1:]
			v = var_get(values, vn, '0')		
			txt = txt.replace(g, str(v))
			return replace_procs(txt, values)
		
		else:
			return txt
	
	except Exception as e:
		return txt

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def check_event(ev, w):
	
	is1 = check_event_condition('1', ev, w)

	if is1 == -1:
		return -1
	
	lc1 = var_get(ev, 'lacznik1', '')	

	if len(lc1) > 0:

		lc2 = var_get(ev, 'lacznik2', '')

		is2 = check_event_condition('2', ev, w)

		if is2 == -1:
			return -1

		if is1 == 1 and is2 == 1 and lc1 == 'and':
			ch = 1
		elif (is1 == 1 or is2 == 1) and lc1 == 'or':
			ch = 1
		else:
			ch = 0

		if len(lc2) > 0:
			is3 = check_event_condition('3', ev, w)
			
			if is3 == -1:
				return -1
			
			if ch == 1 and is3 == 1 and lc2 == 'and':
				ch = 1
			elif (ch == 1 or is3 == 1) and lc2 == 'or':
				ch = 1
			else:
				ch = 0

			return ch

		else:

			return ch

	else:
		return is1
# - - - - - - - - - - - - - - - - - - - - - - - - -
def check_event_condition(nr, ev, w):

	check = 1
	
	if 'warunek'+nr in ev and 'wartosc'+nr in ev and 'wartosc'+nr+'_var' in ev:
		
		z = ev['warunek'+nr]
		if_a = var_get(w, ev['if'+nr], -12345)
		check = 0

		if if_a == -12345:
			return -1

		if z == '~':
		
			if_b = str(ev['wartosc'+nr]) if len(ev['wartosc'+nr]) > 0 else (str(var_get(w, ev['wartosc'+nr+'_var'], "-12345")) if len(ev['wartosc'+nr+'_var']) > 0 else "")

			if if_b == '-12345':
				return -1
			
			if len(str(if_a)) > 0 and len(if_b) > 0 and str(str(if_a)).find(if_b) != -1:
				check = 1
		
		else:
			
			try:
				if_a = float(if_a) if ((type(if_a) is str and len(if_a) > 0) or type(if_a) is int or type(if_a) is float) else -12345
				if_b = check_event_var_get(nr, ev, w)
			except Exception as e:
				if_a = -12345
				if_b = -12345	
			
			if if_a == -12345 or if_b == -12345:
				return -1
			
			if ((z == '=' and (if_a == if_b)) or (z == '>' and (if_a > if_b)) or (z == '<' and (if_a < if_b))):
				check = 1
	else:
		
		check = 1

	return check
# - - - - - - - - - - - - - - - - - - - - - - - - -
def check_event_var_get(nr, ev, w):
	if len(ev['wartosc'+nr]) > 0:
		return float(ev['wartosc'+nr])
	elif len(ev['wartosc'+nr+'_var']) > 0:
		_n = ev['wartosc'+nr+'_var']
		_v = var_get(w, _n, -12345)
		if (type(_v) is int and _v == -12345) or (type(_v) is str and len(_v) == 0):
			return -12345
		else:
			return float(_v)
	else:
		return -12345
# - - - - - - - - - - - - - - - - - - - - - - - - -
'''
def check_str_conditions_on_vars(txt, variables, or_cond = False):
	z = txt.split(';')
	ok = {}
	for vx in z:
		ok[vx] = False
		if vx.find('=') != -1:
			_zmn, _val = vx.split('=')
			if str(var_get(variables, _zmn, '')) == _val:
				ok[vx] = True
		elif vx.find('>=') != -1:
			_zmn, _val = vx.split('>=')
			if str(var_get(variables, _zmn, '')) >= _val:
				ok[vx] = True
		elif vx.find('<=') != -1:
			_zmn, _val = vx.split('<=')
			if str(var_get(variables, _zmn, '')) <= _val:
				ok[vx] = True
		elif vx.find('>') != -1:
			_zmn, _val = vx.split('>')
			if str(var_get(variables, _zmn, '')) > _val:
				ok[vx] = True
		elif vx.find('<') != -1:
			_zmn, _val = vx.split('<')
			if str(var_get(variables, _zmn, '')) < _val:
				ok[vx] = True

	ile_ok = 0
	for a in ok:
		if ok[a] == True:
			ile_ok = ile_ok+1
	
	if or_cond:
		return True if ile_ok > 0 else False
	else:
		return True if ile_ok == len(ok) else False
'''

#