import os
import sys
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from lib.mqtt_class import mqttBroker, mqttSendOne
from read_write import sendCommand2Element, readAllElements

from _config_top import *

def mqttOnActionPrint(a, b):
	tmp = a
	#print('mqttOnActionPrint', a, b)

def mqttReadMessage(o, topic, msg):
	#print(topic, msg)
	if topic == '--sys--':
	
		if msg == 'update':
			ok = mk_php('update.php', 'mqtt')
			o.publish('--sys-update--', 'update:' + ok)
	
		elif msg == 'reboot' or msg == 'restart' :
			o.publish('--sys-reboot--', 'reboot:ok')			
			mk_python('power', 'reboot')
	
		elif msg == 'log_list' or msg == 'logs_list' :
			o.publish('--logs_list_str--', mk_php('index.php', 'logs_list_json'))
		elif msg == 'log_list_devices' or msg == 'logs_list_devices' :
			o.publish('--logs_list_devices_str--', mk_php('index.php', 'logs_list_json', 'devices'))
	
		elif msg == 'status' :
			o.publish('--status_str--', sys_rb_get_all_information(True))
	
		elif msg == 'remote_info' :
			o.publish('--remote_info_str--', mk_php('index.php', 'remote_info_get'))
	
	elif topic == '--configuration-get--':
		o.publish('--configuration-return--', mk_php('index.php', 'configuration_get_mqtt'))
	
	elif topic == '--configuration-save--':
		file_save(ROOT_DIR + 'data/tmp_mqtt_conf.json', msg)
		mk_php('index.php', 'configuration_save_mqtt')
	
	elif topic == 'values':
		if msg == 'read_all':
			o.publish('--values_all_str--', mk_php('index.php', 'read'))

	elif topic == '--backup--':
		if msg == 'local_create':
			o.publish('--backup_msg--', mk_php('index.php', 'backup_action', 'backup_local'))
	
	elif topic == 'module_action':
			ret = ''
			mx = msg.split('=')
			if len(mx) == 2:
				ret = mk_php('index.php', 'module_action', mx[0], mx[1])
			elif len(mx) == 3:
				ret = mk_php('index.php', 'module_action', mx[0], mx[1]+mx[2])
			elif len(mx) == 4:
				ret = mk_php('index.php', 'module_action', mx[0], mx[1]+mx[2]+mx[3])
			
			if len(ret) > 0:
				o.publish('module_action_ret', ret);

	elif topic == 'cmd':
		if msg == '--read-all--':
			mqttSendMessageArray(readAllElements())
		else:
			mx = msg.split('=')
			#print(mx)
			if len(mx) == 2:
				if mx[1].find(',') != -1:
					my = mx[1].split(',')
					ok = sendCommand2Element(mx[0], my[0], my[1])
				else:
					ok = sendCommand2Element(mx[0], mx[1])
				
				if ok:
					ret = var_get(readAllElements(), mx[0])
					mqttSendMessage(mx[0], ret)
			
				if topic != 'cmd-return':
					o.publish('cmd-return', msg)

def mqttSendMessage(topic, message):
	global mqttObj
	
	if mqttObj:
		if type(message) is list:
			msg = ",".join(map(str, message))
			mqttObj.publish(topic, msg)
		else:
			mqttObj.publish(topic, message)

def mqttSendMessageArray(ms):
	for a in ms:
		mqttSendMessage(a, ms[a])

def mqttSendMessageArrayOne(ms):
	global CONFIG_OBJ, MQTT_PARAMS
	mqsp = var_get(CONFIG_OBJ, 'parameters.mqtt_send')

	if MQTT_PARAMS['aktywny'] == '1':
		mqttSendMessageArray(ms)
	elif var_get_int(mqsp, 'aktywny') == 1:
		for a in ms:
			mqttSendOne(mqsp, ms)		


if PLATFORM == 'win':
	print('mqtt start')

def mkConnection_obj():
	global mqttObj, MQTT_PARAMS, mqttReadMessage, mqttOnActionPrint
	mqttObj = mqttBroker(MQTT_PARAMS['server'], int(MQTT_PARAMS['port']), 'raspberryIhome-' + MQTT_PARAMS['ident'] + '-' + MQTT_PARAMS['user'])
	mqttObj.setClientDevice(MQTT_PARAMS['prefix'], MQTT_PARAMS['ident'])
	mqttObj.setFunctionMsg(mqttReadMessage)
	mqttObj.setFunctionEvt(mqttOnActionPrint)
	mqttObj.setSubscribe(['#'], 0)

	if MQTT_PARAMS['aktywny'] == '1':
		if len(MQTT_PARAMS['user']) > 0 and len(MQTT_PARAMS['passwd']) > 0:
			mqttObj.connect(MQTT_PARAMS['user'], MQTT_PARAMS['passwd'])
		else:
			mqttObj.connect()


mkConnection_obj();

x = 0

try:
	
	while 1: 	

		if x == 0:
			mqttSendMessageArray(readAllElements())

		x = x + 1

		o2send = json_file_get(FILE_MQTT_2SEND)
		if len(o2send) > 0:
			json_file_save(FILE_MQTT_2SEND, {})
			mqttSendMessageArray(o2send)

		o2send = json_file_get(FILE_MQTT_2SEND_ONE)
		if len(o2send) > 0:
			json_file_save(FILE_MQTT_2SEND_ONE, {})
			mqttSendMessageArrayOne(o2send)

		
		if x%60 == 0:	#co 1 minute
			sys_workingModules.set('mqtt')
		
		if x == 600:		#co 10 minut
			mqttSendMessageArray(readAllElements())
			x = 1

		time.sleep(1)
 
except KeyboardInterrupt:
	print('Koniec') 