import os
import sys
import time
#from datetime import datetime
import platform

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

PLATFORM = 'win' if platform.system() == 'Windows' else 'rpi'

from lib.rxtx_class import *
from lib.mk_class import dataX
from _config_top import *

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

PORT_OBJ = {}
PORT_OBJ_ELEM = {}

DATA_VAR = dataX(FILE_PORTS_DATA)

def portReadEvent(n, txt):

	#print('portReadEvent', n, txt)

	DATA_VAR.set(n, txt, True)

	for a in CONFIG_OBJ['ports']:

		if a['typ'] == 'element' and a['definicja'] == n:
			if len(a['wyrazenie']['nie'])>0 and str(txt).find(a['wyrazenie']['nie']) != -1:
				DATA_VAR.set(a['nazwa'], 0, True)
			elif len(a['wyrazenie']['tak'])>0 and str(txt).find(a['wyrazenie']['tak']) != -1:
				DATA_VAR.set(a['nazwa'], 1, True)


for a in CONFIG_OBJ['ports']:
	n = a['nazwa']

	if a['typ'] == 'definicja' and a['rodzaj'] == 'serial' and len(a['port']['numer'])>0 and len(a['port']['predkosc'])>0 and len(a['port']['czas'])>0:
		PORT_OBJ[n] = rxtx(a['port']['numer'], int(a['port']['predkosc']), float(a['port']['czas']))
		
		PORT_OBJ[n].setReadEvt(portReadEvent, n)
		PORT_OBJ[n].start()
	elif a['typ'] != 'definicja':
		PORT_OBJ_ELEM[n] = a


def check2do():	
	global FILE_PORTS2DO_DATA
	
	d = json_file_get(FILE_PORTS2DO_DATA)
		
	if len(d) > 0:
		_k, _v = d.popitem()
		
		#if PORT_OBJ[_k]:
		if _k in PORT_OBJ:
			PORT_OBJ[_k].write(_v)
		elif _k in PORT_OBJ_ELEM:
			n = PORT_OBJ_ELEM[_k]['definicja']
			PORT_OBJ[n].write(_v)
		
		json_file_save(FILE_PORTS2DO_DATA, d)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

if PLATFORM == 'win':
	print('ports start')

x = 1;

#PORT_OBJ['xxxxxxxxxx'].testEvent('1111')
#PORT_OBJ['yyyyyyyyyy'].testEvent('22222222')

try:
	
	while 1: 	

		x = x + 1

		if x % 10 ==0:
			#co sekunde
			check2do()

		if x == 600:
			x = 1
			sys_workingModules.set('ports')
		
		time.sleep(0.1)
 
except KeyboardInterrupt:

	for a in PORT_OBJ:
		PORT_OBJ[a].stop()

	print('Koniec') 

