import sys
import os
import re
import json
from datetime import datetime
from threading import Timer
import threading
import base64

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from lib.mk_class import *
from lib.outin_class import *

from _config_top import *

if PLATFORM == 'rpi':
	import RPi.GPIO as GPIO
	GPIO.setwarnings(False)
	GPIO.setmode(GPIO.BCM)

SQL = msqlLite(SQL_PATH)
SQL_WORK = msqlLite(SQL_PATH, 'work')

VARIABLES_OBJ = dataX(FILE_REPOSITORY, 'variables')
PWM_OBJ = dataX(FILE_PWM_DATA)
GPI_OBJ = gpioOutIn(CONFIG_OBJ['gpio'], DIR_QUICK_MEM if PLATFORM == 'win' else '')
#RFLINK_OBJ = dataX(FILE_RFLINK_DATA, 'rflink')

_nazwa =var_get(sys.argv, 1, '')
_action = str(var_get(sys.argv, 2, ''))
_param = str(var_get(sys.argv, 3, ''))
_options = str(var_get(sys.argv, 4, ''))

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def rw_send2quickmem(n, cmdStr, paramStr=''):
	global DIR_QUICK_MEM

	if os.path.isdir(DIR_QUICK_MEM) != False:
		str2save = cmdStr + ':' + paramStr if len(paramStr)>0 else cmdStr
		file_save(DIR_QUICK_MEM + n + '.cmd', str2save)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def rw_sendImage2iHomeTHDUrl(o):
		return 'http://' + o['ip'] + (':' + o['port'] if len(o['port']) > 0 else '') + '/'


def rw_sendImage2iHomeTHD(obj, cmd):
	global FILE_CAMERAS_DATA
	
	_n = obj["nazwa"]
	
	json_file_save(FILE_CAMERAS_DATA, {_n:"wait"}, True)

	url = rw_sendImage2iHomeTHDUrl(obj) + obj['sciezka']

	_login = var_get(obj, 'access.login', '')
	_pass = var_get(obj, 'access.passwd', '')				
	
	if len(_login)>0 and len(_pass)>0:
		_ok, _img = http_get(url, 7, 'image', {'auth' : [_login, _pass]})
	else:
		_ok, _img = http_get(url, 7, 'image')
	
	if _ok:
		ok = True
		if cmd == "send2ihome":
			_ok2, _ret = http_post(IHOME_URL + 'cam-image-write/'+IHOME_IDENT+'/'+IHOME_KEY+'/'+_n, {'image' : _img}, 3)
			if _ok2:					
				json_file_save(FILE_CAMERAS_DATA, {_n:"send2ihome ok, "+datetime.now().strftime("%Y-%m-%d %H:%M")}, True)
			else:
				json_file_save(FILE_CAMERAS_DATA, {_n:"error send2ihome: "+_ret}, True)
		else:
			json_file_save(FILE_CAMERAS_DATA, {_n:"bad command"}, True)
	else:
		json_file_save(FILE_CAMERAS_DATA, {_n:"error get: "+_img}, True)		


def rw_sendImage2iHome(obj, action):
	thread = threading.Thread(target=rw_sendImage2iHomeTHD, args=(obj, action, ))
	thread.start()

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def sendCommand2Element(_n, _action = '', _param = '', _options = ''):

	global CONFIG_OBJ
	global SQL
	global SQL_WORK

	global VARIABLES_OBJ
	global PWM_OBJ
	global GPI_OBJ	
	
	global FILE_VARIABLES_SPECIAL
	global FILE_PORTS2DO_DATA

	global FILE_DEVICES_DATA
	global FILE_CAMERAS_DATA
	global FILE_MQTT_2SEND_ONE

	devices = var_get(CONFIG_OBJ, 'devices', [])
	cameras = var_get(CONFIG_OBJ, 'cameras', [])
	zigbee = var_get(CONFIG_OBJ, 'zigbee', [])
	gpio = var_get(CONFIG_OBJ, 'gpio', [])
	variables = var_get(CONFIG_OBJ, 'variables', [])
	ports = var_get(CONFIG_OBJ, 'ports', [])
	rs485 = var_get(CONFIG_OBJ, 'rs485', [])
	i2c = var_get(CONFIG_OBJ, 'i2c', [])
	rflink = var_get(CONFIG_OBJ, 'rflink', [])
	events = var_get(CONFIG_OBJ, 'events', [])
	events_time = var_get(CONFIG_OBJ, 'time', [])
	tasks = var_get(CONFIG_OBJ, 'tasks', [])

	_action = _action.replace(' ', '')
	_param = _param.replace(' ', '')

	if len(_options) > 0:
		if _options.find('log') != -1:
			add2loguser('read_write', _n, {'action':_action, 'param':_param})

	ok = False	
	is_find = False

	for a in devices:
		if a['typ'] == 'comp':
			if a['nazwa'] == _n:
				if var_get_int(a, 'aktywny') == 1:
					wake_up_on_lan(a['mac'], BROADCAST_IP)
				is_find = True
				ok = True				

	if is_find == False:
		for a in cameras:
			if a['nazwa'] == _n:
				if var_get_int(a, 'aktywny') == 1:
					#rw_sendImage2iHome(a, _action)
					cam_img = mk_php('index.php', 'cameras', 'save_image', _n)
					json_file_add_var(FILE_MQTT_2SEND_ONE, _n, cam_img)
				
				is_find = True
				ok = True
	
	if is_find == False:
		is_find, ok, dv_val = devices_do.send2device(CONFIG_OBJ['devices'], _n, _action)
		if ok:
			#json_file_add_var(FILE_DEVICES_DATA, _n, dv_val)
			SQL.setVal('devices', _n, dv_val)
	
	if is_find == False:
		
		for a in gpio:
		
			if a['nazwa'] == _n:
		
				is_find = True

				if a['typ'] == 'out_d_0':
					GPI_OBJ.out_set_toggle(_n)
					ok = True
				
				elif a['typ'] == 'pwm':
					act =  PWM_OBJ.get(_n, [0, 0]);

					_action = int(_action) if len(_action)>0 else act[0]
					pw = int(_param) if len(_param) > 0 else 0

					if _action == -1:
						act[0] = 1 if act[0] == 0 else 0
					else:
						act[0] = 1 if _action == 1 else 0

					if pw > 0:
						act[1] = pw;
					
					PWM_OBJ.set(_n, act, True)
					ok = True

	
	if is_find == False:
		for a in variables:
			
			if a['nazwa'] == _n:
				is_find = True
				v_act = VARIABLES_OBJ.get(_n, 0)
				if a['typ'] == 'yn':
					if _action == '-1':
						v_set = 1 if v_act == 0 else 0
					else:
						v_set = int(_action)
				elif a['typ'] == 'number':
					v_set = float(_action) if len(_action)>0 else 0
				elif a['typ'] == 'time':
					v_set = _action if len(_action)==5 else ''
				elif a['typ'] == 'counter':
					if as_number(_param) == 1:
						v_set = as_number(_action)
					else:
						v_set = as_number(v_act) + as_number(_action)
				elif a['typ'] == 'exp':
					SQL.setVal('vars_exp', _n, re.sub("[^a-zA-Z_0-9\-]", "", _action))
				else:
					v_set = re.sub("[^a-zA-Z_0-9\-]", "", _action)
				
				if a['typ'] != 'exp' and v_act != v_set:
					VARIABLES_OBJ.set(_n, v_set, True)
				
				ok = True

	
	if is_find == False:
		for a in variables:
			if a['nazwa'] == _n:
				is_find = True
				if a['typ'] == 'exp':
					SQL.setVal('vars_exp', _n, re.sub("[^a-zA-Z_0-9\-]", "", _action))
				ok = True

	
	if is_find == False:
		for a in ports:
			if a['nazwa'] == _n:
				is_find = True				
				if len(_param) > 0:
					_action += ',' + _param
				json_file_add_var(FILE_PORTS2DO_DATA, _n, _action)

	
	if is_find == False:
		for a in rs485:
			if a['nazwa'] == _n:
				is_find = True
				if len(_param) > 0:
					_action += ',' + _param
				#json_file_add_var(FILE_RS485_2DO_DATA, _n, _action)
				SQL.setVal('rs485_cmd', _n, _action)

				if _action == "1" or _action == "0" or _action == "-1":
					#_d48 = json_file_get(FILE_RS485_DATA)
					#_cval = var_get(_d48, _n)
					#_d48[_n] = 1 if _action=="1" or (_cval==0 and _action=="-1") else 0
					#json_file_save(FILE_RS485_DATA, _d48)
					try:
						_cval = int(SQL.getVal('rs485', _n, 0))
						SQL.setVal('rs485', _n, 1 if _action=="1" or (_cval==0 and _action=="-1") else 0)
					except:
						pass						
	
	if is_find == False:
		for a in i2c:
			if a['nazwa'] == _n:
				is_find = True
				if len(_param) > 0:
					_action += ',' + _param
				#json_file_add_var(FILE_I2C2DO_DATA, _n, _action) 
				SQL.setVal('i2c_cmd', _n, _action);

	
	if is_find == False:
		for a in rflink:
			if a['nazwa'] == _n:
				is_find = True
				#json_file_add_var(FILE_RFLINK2DO_DATA, _n, _action)
				SQL.setVal('rflink_cmd', _n, _action);
				ok = True

	if is_find == False:
		for a in zigbee:
			if a['nazwa'] == _n:
				is_find = True
				SQL.setVal('zigbee_cmd', _n, _action);
				ok = True

	
	if is_find == False:
		for a in events:
			if a['nazwa'] == _n and (_action == "1" or _action == "-1"):
				is_find = True
				#json_file_add_var (FILE_ACTIONS_TEST_2DO, _n, 1)
				#SQL.insertVal('events_2do', _n, 1)
				SQL.insertVal('events_2do', uniqid('event_'), _n)
				ok = True

	if is_find == False:
		for a in events_time:
			if a['nazwa'] == _n and (_action == "1" or _action == "-1"):
				is_find = True
				#json_file_add_var (FILE_ACTIONS_TEST_2DO, _n, 1)
				#SQL.insertVal('events_2do', _n, 1)
				SQL.insertVal('events_2do', uniqid('times_'), _n)
				ok = True

	if is_find == False:
		for a in tasks:
			if a['nazwa'] == _n and (_action == "1" or _action == "-1"):
				is_find = True
				#json_file_add_var (FILE_ACTIONS_TEST_2DO, _n, 1)
				#SQL.insertVal('events_2do', _n, 1)
				SQL.insertVal('events_2do', uniqid('tasks_'), _n)
				ok = True				

	if is_find == False:
		if _n == 'power':
			is_find = True
			if _action == 'shutdown' or _action == 'reboot':
				SQL.insertVal('events_2do', _n, _action)

	if _n == '_boiler_ot_co_boost':
		SQL_WORK.setValArr('boiler_ot', 'boost_start', [_action, _param], ':');
		#rw_send2quickmem('_boiler_ot_co_boost', _action, _param)
		ret_bot_nobtxpaqsd1()

	return ok

#po 5 sekundach boiletot.py powinien przepisac zmienne
from threading import Timer
def ret_bot_nobtxpaqsd1():
	r = Timer(5.0, ret_bot_nobtxpaqsd2)
	r.start()
def ret_bot_nobtxpaqsd2():
	global FILE_MQTT_2SEND
	d = vars_ex.boiler_ot()
	json_file_add_var(FILE_MQTT_2SEND, '_boiler_ot', d)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def readAllElements():
	global SQL
	global SQL_WORK
	global FILE_PORTS_DATA
	#global FILE_I2C_DATA
	#global FILE_RS485_DATA
	global FILE_CAMERAS_DATA
	#global RFLINK_OBJ
	global VARIABLES_OBJ
	global PWM_OBJ
	global DIR_QUICK_MEM

	devices = var_get(CONFIG_OBJ, 'devices', [])
	gpio = var_get(CONFIG_OBJ, 'gpio', [])
	variables = var_get(CONFIG_OBJ, 'variables', [])
	ports = var_get(CONFIG_OBJ, 'ports', [])
	rs485 = var_get(CONFIG_OBJ, 'rs485', [])
	i2c = var_get(CONFIG_OBJ, 'i2c', [])
	rflink = var_get(CONFIG_OBJ, 'rflink', [])
	boiler_ot = var_get(CONFIG_OBJ, 'boiler_ot', [])
	zigbee = var_get(CONFIG_OBJ, 'zigbee', [])

	zwrot = {}

	PWM_OBJ.refresh()
	VARIABLES_OBJ.refresh()
	#RFLINK_OBJ.refresh()

	COMPS_OBJ_DATA = SQL.getValues('pings')#json_file_get(FILE_COMPS)
	#DEVICES_OBJ_DATA = json_file_get(FILE_DEVICES_DATA)
	DEVICES_OBJ_DATA = SQL.getValues('devices')

	zwrot = DEVICES_OBJ_DATA
	zwrot = obj_merge(zwrot, COMPS_OBJ_DATA)

	sens_data = json_file_get(FILE_SENSORS)

	for a in gpio:

		if len(a["nazwa"]) > 0:

			n = a["nazwa"]

			if a['typ'] == 'ds18b20':
				zwrot[n] = var_get(sens_data, n, 0)

			elif a['typ'] == 'out_d_0':
				zwrot[n] = GPI_OBJ.out_get(n)

			elif a['typ'] == 'input_d_1':
				zwrot[n] = GPI_OBJ.in_get(n)

			elif a['typ'] == 'pwm':				
				zwrot[n] = PWM_OBJ.get(n, [0,0]);

	for a in variables:
		n = a["nazwa"]
		zwrot[n] = VARIABLES_OBJ.get(n, '')

	zwrot = obj_merge(zwrot, SQL.getValues('vars_exp'))

	ports_data = json_file_get(FILE_PORTS_DATA)	
	for a in ports:
		n = a["nazwa"]
		zwrot[n] = var_get(ports_data, n, '')

	rs485_data = SQL.getValues('rs485')
	for a in rs485:
		n = a["nazwa"]
		zwrot[n] = var_get(rs485_data, n, '')

	i2c_data = SQL.getValues('i2c')#json_file_get(FILE_I2C_DATA)	
	for a in i2c:
		n = a["nazwa"]
		zwrot[n] = var_get(i2c_data, n, '')
 
	rflink_data = SQL.getValues('rflink')
	for a in rflink:
		n = a["nazwa"]
		#zwrot[n] = RFLINK_OBJ.get(n, "")
		zwrot[n] = var_get(rflink_data, n, '')

	zigbee_data = SQL.getValues('zigbee')
	for a in zigbee:
		n = a["nazwa"]
		zwrot[n] = var_get(zigbee_data, n, '')

	zwrot = obj_merge(zwrot, json_file_get(FILE_CAMERAS_DATA))

	zwrot["_modules"] = sys_workingModules.getStr()

	'''
	zwrot["_boiler_ot"] = ''
	zwrot["_boiler_ot"] += 'co='+str(var_get(zwrot, var_get(boiler_ot, 'var.co_czy_aktywny', '?'), '0'))
	zwrot["_boiler_ot"] += '|cw='+str(var_get(zwrot, var_get(boiler_ot, 'var.cwu_czy_aktywny', '?'), '0'))
	zwrot["_boiler_ot"] += '|ks='+var_get(boiler_ot, 'kg.s', '')
	zwrot["_boiler_ot"] += '|kn=' + var_get(boiler_ot, 'kg.n', '')
	zwrot["_boiler_ot"] += '|tc=' + SQL_WORK.getVal('boiler_ot', 'temp_curve', '0')
	zwrot["_boiler_ot"] += '|tr=' + var_get(boiler_ot, 'temp.rano', '')
	zwrot["_boiler_ot"] += '|td=' + var_get(boiler_ot, 'temp.dzien', '')
	zwrot["_boiler_ot"] += '|tw=' + var_get(boiler_ot, 'temp.wieczor', '')
	zwrot["_boiler_ot"] += '|tn=' + var_get(boiler_ot, 'temp.noc', '')
	
	[_boiler_ot_temp, _boiler_ot_do_kiedy] = SQL_WORK.getValArr('boiler_ot', 'boost_param', ['0', '00:00'], ';')
	zwrot["_boiler_ot"] += '|bt=' + (_boiler_ot_temp + ';' + _boiler_ot_do_kiedy if _boiler_ot_temp != '0' else '')
	'''

	zwrot["_boiler_ot"] = vars_ex.boiler_ot()

	zwrot = obj_merge(zwrot, sys_var_spec.get_all(), '_vs_')
	zwrot = obj_merge(zwrot, sys_err.get_all(), '_err_')
	zwrot = obj_merge(zwrot, sys_info.get_usage(), '_inf_')
	zwrot = obj_merge(zwrot, sys_var_const.get_all(), '_')
	
	zwrot['_note_list'] = "|".join(sys_note.get())

	return zwrot

#_nazwa = '--read-all--'
#_action = 'connect'
#_param = 'lk_dol'

if len(_nazwa) > 0:
	if _nazwa == '--read-all--':
		if _action == 'connect':
			if len(_param) > 0:
				zw = {}#devices_do.read_all(CONFIG_OBJ['devices'], _param)
				#SQL.setValues('devices', zw)
			else:
				zw = {}#devices_do.read_all(CONFIG_OBJ['devices'])
				#SQL.setValues('devices', zw, {'clear' : True})
				
		zw = readAllElements()
	else:
		sendCommand2Element(_nazwa, _action, _param, _options)
		zw = readAllElements()

	jstr = json.dumps(zw)
	print(jstr)