import os
import sys
import time
#from datetime import datetime

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from lib.rxtx_class import *
from lib.mk_class import dataX
from _config_top import *

if PLATFORM == 'rpi':
	import RPi.GPIO as GPIO
	GPIO.setwarnings(False)
	GPIO.setmode(GPIO.BCM)	

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

SQL = msqlLite(SQL_PATH)
SQL_REPLY = msqlLite(SQL_PATH, 'reply')

RS_ACTIVE = False
RSE = False
PORT_OBJ = {}
DATA_X = []
DATA_VAR = {}
DATA_MEM = {}
CURRENT_X = 0
REPLY = {'name' : False, 'ident ' :'', 'cmd' : '', 'x' : 0}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def setInitialData2Rs(is_start = False):
	global FILE_CONFIG, PORT_OBJ, DATA_X, RSE, RS485, RS_ACTIVE, DATA_VAR, FILE_RS485_DATA, errDevices

	PORT_OBJ = {}
	DATA_X = []

	all_fields = []

	_rc_all = json_file_get(FILE_CONFIG, {});	
	_rc_start = var_get(_rc_all, 'parameters.rs485', {})
	_rc_elem = var_get(_rc_all, 'rs485')

	if is_start:				
		RS485._dlugosc = int(_rc_start['cmd']['dlugosc'])
		RS485._znak_p = _rc_start['cmd']['znak_p']
		RS485._znak_k = _rc_start['cmd']['znak_k']
		RS485._rozdz = _rc_start['cmd']['znak_r']

		if len(str(_rc_start['pin_kierunek'])) > 0 and RS485.pin == 0:
			RS485.setPinDirection(int(_rc_start['pin_kierunek']))

		if RSE == False:
			RSE = rxtx(_rc_start['port']['numer'], int(_rc_start['port']['predkosc']), int(_rc_start['port']['czas']))
			RSE.setReadEvt(rs485GetDataEvent)
			RSE.start()	
	
	RS_ACTIVE = var_get_int(_rc_start, 'aktywny') == 1

	for a in _rc_elem:
		n = a['nazwa']

		if var_get_int(a, 'aktywny') == 1:
			
			if a['typ'] == 'definicja':
				if is_start:
					errDevices.addDevice(a['urzadzenie_nazwa'], var_get_len(a, 'opis', n))
				DATA_X.append(n)
				a['_elements'] = []
				PORT_OBJ[n] = a
				if is_start:
					DATA_VAR[n] = ""
			
			elif a['typ'] == 'element':
				if a['definicja'] in PORT_OBJ:
					PORT_OBJ[a['definicja']]['_elements'].append(a)
					if is_start:
						DATA_VAR[a["nazwa"]] = ""

		if a['typ'] == 'definicja' or a['typ'] == 'element':
			all_fields.append(a['nazwa'])

	updateInactiveElements(all_fields)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def updateInactiveElements(all):
	global PORT_OBJ
	global DATA_VAR
	global CURRENT_X
	global SQL
	
	act = []

	for a in PORT_OBJ:
		act.append(PORT_OBJ[a]['nazwa'])
		for b in PORT_OBJ[a]['_elements']:
			act.append(b['nazwa'])
	
	d = []

	for a in all:
		if a not in act:
			d.append(a)

	if len(d) > 0:
		#CURRENT_X = 0
		SQL.delVal('rs485', d)
		DATA_VAR = obj.rm_keys(DATA_VAR, d)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class r485:
	def __init__(self):
		self.pin = 0
		self._rozdz = '#'
		self._dlugosc = 10
		self._znak_p = '^'
		self._znak_k = '$'

	def setPinDirection(self, pin):
		global PLATFORM

		if pin > 0 and PLATFORM == 'rpi':
			self.pin = pin
			GPIO.setup(self.pin, GPIO.OUT)
			GPIO.output(self.pin, GPIO.LOW)		

	def addString2length(self, txt):
		txt = self._znak_p + txt
		i = len(txt)
		while i < self._dlugosc:
			txt = txt + self._znak_k
			i = i+1
		
		return txt

	def send(self, n, txt):
		global errDevices
		errDevices.setPing(n)
		txt = self.addString2length(n + self._rozdz + txt)
		self.send2Rxtx(txt)

	def sendCmd(self, d, n, txt):
		global errDevices
		errDevices.setPing(d)
		txt2 = self.addString2length(d + self._rozdz + n + "=" + txt)
		self.send2Rxtx(txt2)		

	def check(self, txt):
		global errDevices
		errDevices.setPing(txt)
		txt = self.addString2length(txt)
		self.send2Rxtx(txt)

	def send2Rxtx(self, txt):
		global PLATFORM, RSE, DATA_MEM
		
		#if PLATFORM == 'win':
		#	print('send', txt)
		
		if RSE:

			DATA_MEM[fn.date_full(True)] = '>&nbsp;' + fn.simple_chars(txt)

			if self.pin > 0 and PLATFORM == 'rpi':

				#DATA_MEM[fn.date_full(True)] = '>&nbsp;' + fn.simple_chars(txt)

				GPIO.output(self.pin, GPIO.HIGH)
				time.sleep(0.1)
				RSE.write(txt)
				time.sleep(0.1)
				GPIO.output(self.pin, GPIO.LOW)
				time.sleep(0.1)
			else:
				RSE.write(txt)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def rs485GetDataEvent(txt):
	global SQL
	global SQL_REPLY
	global PORT_OBJ
	global DATA_VAR
	global DATA_MEM
	global REPLY
	
	if txt.find(RS485._rozdz) != -1:

		try:
			_un, _str = txt.split(RS485._rozdz)
		except:
			_str = ''
			pass
		
		if len(_str) > 0:
			
			if _un[0:1] == '^':
				_un = _un[1:]

			if _un.find('^') > -1:#jak bedzie coś wcześniej
				_un = _un[_un.find('^')+1:] 

			_str = fn.simple_chars(_str)
			
			#print(_str, _un)
			for a in PORT_OBJ:
				
				if PORT_OBJ[a]['urzadzenie_nazwa'] == _un:

					errDevices.setReply(_un)
					
					if str(_str).find('cmd-ok') != -1:
					
						REPLY['name'] = False
						REPLY['x'] = 0
					
					else:

						DATA_VAR[PORT_OBJ[a]['nazwa']] = _str

						for b in PORT_OBJ[a]['_elements']:
							if len(b['wyrazenie']['nie'])>0 and str(_str).find(b['wyrazenie']['nie']) != -1:
								DATA_VAR[b['nazwa']] = 0
							elif len(b['wyrazenie']['tak'])>0 and str(_str).find(b['wyrazenie']['tak']) != -1:
								DATA_VAR[b['nazwa']] = 1
							elif len(b['number_val']['reg'])>0 and len(_str)>=2:

								if len(b['number_val']['proc_min'])>0 and len(b['number_val']['proc_max'])>0:
									vv = value.expression(_str, b['number_val']['reg'], -123456, [b['number_val']['proc_min'], b['number_val']['proc_max']])
								else:
									vv = value.expression(_str, b['number_val']['reg'], -123456)	

								watch_step = as_number(b['number_val']['watch_step'], 0, True)

								if watch_step > 0 and vv != -123456:
									vv = step_number.check('rs485_' + b['nazwa'], vv, watch_step, -123456)

								if vv != -123456:
									DATA_VAR[b['nazwa']] = vv

			DATA_MEM[fn.date_full(True)] = '<&nbsp;&nbsp;&nbsp;' + fn.simple_chars(_un + ':' + _str)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def check2do():
	global PORT_OBJ
	global CURRENT_X
	global REPLY
	global FILE_RS485_2DO_DATA
	global SQL

	if REPLY['name'] != False:

		if REPLY['cmd'] != False:
			RS485.sendCmd(REPLY['name'], REPLY['ident'], REPLY['cmd'])
		else:
			RS485.send(REPLY['name'], REPLY['ident'])

		if REPLY['x'] < 3:
			REPLY['x'] = REPLY['x'] + 1
		else:
			REPLY['name'] = False
			REPLY['x'] = 0

	else:

		#d = json_file_get(FILE_RS485_2DO_DATA)
		dx2do = SQL.getValues('rs485_cmd')

		if len(dx2do) > 0:
			_k, _v = dx2do.popitem()
			#print(_k, _v)
			
			if _k in PORT_OBJ:
				RS485.send(PORT_OBJ[_k]['urzadzenie_nazwa'], _v)
				REPLY = {'name' : PORT_OBJ[_k]['urzadzenie_nazwa'], 'ident' : _v, 'cmd' : False, 'x' : 0}
			else:
				for a in PORT_OBJ:
					for b in PORT_OBJ[a]['_elements']:
						_un = PORT_OBJ[a]['urzadzenie_nazwa']
						if b['nazwa'] == _k:
							RS485.sendCmd(_un, b['ident'], _v)
							REPLY = {'name' : _un, 'ident' : b['ident'], 'cmd' : _v, 'x' : 0}

			#json_file_save(FILE_RS485_2DO_DATA, d)
			SQL.delVal('rs485_cmd', _k)

		else:
			
			if len(DATA_X) > 0:
				
				try:
					n = DATA_X[CURRENT_X]

					RS485.check(PORT_OBJ[n]['urzadzenie_nazwa'])

					CURRENT_X = CURRENT_X + 1

					if CURRENT_X > len(DATA_X) - 1:
						CURRENT_X = 0
				except:
					pass

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def r485TryAdd2globalErr():
	global errDevices
	
	err = errDevices.getErr()
	
	if len(err) > 0:
		sys_conn_error.set('rs485', err)
	else:		
		sys_conn_error.set('rs485', '')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

errDevices = connErr(5)
RS485 = r485()
setInitialData2Rs(True)
sys_workingModules.set('rs485')

if PLATFORM == 'win':
	print('rs485 start')

x = 0
#RSE.testEvent('^cz#w23.67a=120_dd$')
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

try:
	
	while 1: 	

		x = x + 1
		
		if x%10 == 0:
			if RS_ACTIVE:
				SQL.setValues('rs485', DATA_VAR)
			#print(DATA_VAR)
		
		#if x%7 == 0:
			#DATA_MEM = SQL.setSortLimit('rs485_reply', DATA_MEM, 20)
	

		#if x % 7 == 0:#co 0,7 sek.
		if x % 10 == 0:#co 1 sek.
			
			if RS_ACTIVE:
				check2do()			
				DATA_MEM = SQL_REPLY.setSortLimit('rs485', DATA_MEM, 30)
			
			'''
			ss1=file_read('_a.txt', '')
			if len(ss1) > 0:				
				if as_number(ss1) == 1000:
					file_save('_a.txt', '')
				ss1 = '^cz#a='+ss1+''				
				RSE.testEvent(ss1)
			
			ss2=file_read('_b.txt', '')
			if len(ss2) > 0:
				if as_number(ss2) == 1000:
					file_save('_b.txt', '')
				ss2 = '^kc#is='+ss2+''
				RSE.testEvent(ss2)
			'''

		#if x % 12 ==0:
		#	RSE.testEvent('^cz#w23.67okd=120_dd$')
		#elif x % 24 ==0:
		#	RSE.testEvent('#test:')
		
		if x % 100 == 0: #co 10 sekund
			r485TryAdd2globalErr()

		if x == 600:#co minute
			setInitialData2Rs()
			x = 0
			sys_workingModules.set('rs485')

		time.sleep(0.1)
 
except KeyboardInterrupt:

	if RSE:
		RSE.stop()

	print('Koniec') 